﻿using System;
using System.Linq;
using System.Linq.Expressions;
using System.Collections.Generic;

namespace Achiral.Extension
{
    public static partial class MakeWorld
    {
        public static IEnumerable<int> GetIndices(this Array array, int dimension)
        {
            AssertNonNullArgument(array, "array");

            return array.GetLowerBound(dimension).UpTo(array.GetUpperBound(dimension));
        }
    }
}