﻿using System;
using System.Text;
using System.Collections.Generic;
using System.Linq;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using Achiral;
using Achiral.Extension;
using System.Reflection;

namespace Achiral.Test
{
    /// <summary>
    /// Summary description for UnitTest1
    /// </summary>
    [TestClass]
    public class ArrayTest
    {
        public ArrayTest()
        {
            //
            // TODO: Add constructor logic here
            //
        }

        /// <summary>
        ///Gets or sets the test context which provides
        ///information about and functionality for the current test run.
        ///</summary>
        public TestContext TestContext { get; set; }

        #region Additional test attributes
        //
        // You can use the following additional attributes as you write your tests:
        //
        // Use ClassInitialize to run code before running the first test in the class
        // [ClassInitialize()]
        // public static void MyClassInitialize(TestContext testContext) { }
        //
        // Use ClassCleanup to run code after all tests in a class have run
        // [ClassCleanup()]
        // public static void MyClassCleanup() { }
        //
        // Use TestInitialize to run code before running each test 
        // [TestInitialize()]
        // public void MyTestInitialize() { }
        //
        // Use TestCleanup to run code after each test has run
        // [TestCleanup()]
        // public void MyTestCleanup() { }
        //
        #endregion

        [TestMethod]
        public void GetIndices_Test1()
        {
            var lengths = new[] { 10, 11, 12, 13 };
            var lowerBounds = new[] { -5, 3, 0, 2 };

            var array = Array.CreateInstance(typeof(int), lengths, lowerBounds);

            0.UpTo(lowerBounds.Length - 1)
             .ForEach(i => Assert.IsTrue(array.GetIndices(i).SequenceEqual(Enumerable.Range(lowerBounds[i], lengths[i]))));
        }

    }
}
